package with_inheritance;

/*
 * All attributes and methods declared in Student
 * are inherited to ResidentStudent.
 * 
 * 1. You cannot re-declare the inherited attributes.
 * 2. If you are satisfied with the inherited method (e.g., register)
 * 		you can choose to leave it implicit. 
 * 3. If you are not satisfied with the inherited method (e.g., getTuition)
 * 		you can choose to override it.
 * 4. You can also add NEW attributes or NEW methods.
 */
public class NonResidentStudent extends Student {
	/*
	 * We do not have to re-declare names, courses, and noc.
	 * We also do not have to override the register method.
	 */
	
	NonResidentStudent(String name) {
		// Invoke the constructor in the super class Student.
		super(name);
	}
	
	/*
	 * Define new attribute and method 
	 * unique to RS.
	 */
	double discountRate;
	void setDiscountRate(double discountRate) {
		this.discountRate = discountRate;
	}
	
	/*
	 * Override/Redfine the getTutition method inherited from Student.
	 */
	double getTuition() {
		// Compute the base amount using the version of getTuition from Student.
		double base = super.getTuition();
		return base * this.discountRate;
	}
}
